#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=icone\icone.ico
#AutoIt3Wrapper_outfile=Ariane.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Comment=Ariane
#AutoIt3Wrapper_Res_Description=File indexer
#AutoIt3Wrapper_Res_Fileversion=0.0.0.1
#AutoIt3Wrapper_Res_LegalCopyright=VooDoo Code
#AutoIt3Wrapper_Res_Language=1036
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#cs ----------------------------------------------------------------------------
	AutoIt Version: 3.2.10.0
	Author:       Voodoo
	Ariane Version  : 0.0.0.1
	Fil version: 0.0.0.1
	Script Function: Search File in your system !
#ce ----------------------------------------------------------------------------

#include <GUIConstants.au3>
#include <array.au3>
#include <Process.au3>
#Include <GuiComboBox.au3>
#include <date.au3>

;--------------------------------
#include "includes/A_load.au3"
#include "includes/A_options.au3"
#include "includes/A_search.au3"
#include "includes/A_Globals.au3"
; -------------------------------

$gui_principale = GUICreate("Ariane", $X_gui * 250, $Y_gui * 40, 40, 40, -1, $WS_EX_TOOLWINDOW + $WS_EX_TOPMOST)
$inp_search = GUICtrlCreateInput("", 0, 0, 250 * $X_gui, 20 * $Y_gui, $ES_CENTER)
GUICtrlSetTip(-1, "Tapez le nom que Ariane doit chercher et appuyez sur Ctrl+Entre", "Recherche:", 1, 0)
$but_option = GUICtrlCreateButton("Options", 0, 20 * $Y_gui, 250 * $X_gui, 20 * $Y_gui)
GUICtrlSetTip(-1, "Grer les Filtres et l'indexation", "Options:", 1, 0)

_load()

GUISetState()
HotKeySet("^{Enter}", "Search")

While 1
	If $timer <> 0 And TimerDiff($timer) > 5000 Then
		ToolTip("")
		$timer = 0
	EndIf
	
	$msg = GUIGetMsg(1)
	Switch $msg[0]
		Case $GUI_EVENT_CLOSE
			
			Switch $msg[1]
				Case $gui_principale
					Exit
				Case Else
					GUIDelete($msg[1])
					WinSetTrans("Ariane", "", 255)
					$on_search = 0
					
			EndSwitch
			
		Case $menu_ouvrir
			$data = StringSplit(GUICtrlRead(GUICtrlRead($listview)), "|")
			If $data[0] > 3 Then _RunDOS('"' & $data[3] & '"')
			
		Case $menu_infos
			$data = StringSplit(GUICtrlRead(GUICtrlRead($listview)), "|")
			$pos = MouseGetPos()
			If $data[0] > 3 Then
				$tip = ToolTip(@LF & "Taille: " & Affichage(FileGetSize($data[3])) & @LF & "Cre: " & filetime(FileGetTime($data[3])) & @LF & "Modifi: " & filetime(FileGetTime($data[3], 1)) & @LF & "Dernier accs: " & filetime(FileGetTime($data[3], 2)) & @LF & "Version: " & FileGetVersion($data[3]), $pos[0], $pos[1], $data[2], 1, 4)
				$timer = TimerInit()
			EndIf
		Case $menu_explore
			$data = StringSplit(GUICtrlRead(GUICtrlRead($listview)), "|")
			$string = StringReplace(StringTrimRight($data[3], StringLen($data[2])), "/", "\")
			If $data[0] > 3 Then _RunDOS('explorer "' & $string & '"')

		Case $but_option
			If WinExists("Ariane: Options") = 0 Then gui_option()
	EndSwitch
WEnd

Func alow_read($text)
	For $i = 1 To $Filtre_read_file[0]
		If StringRight($text, StringLen($Filtre_read_file[$i])) = $Filtre_read_file[$i] Then Return 1
	Next
	Return 0
EndFunc   ;==>alow_read

Func Affichage($inputbytes)
	If $inputbytes < 1024 Then Return Round($inputbytes) & "b"
	If $inputbytes > 1024 And $inputbytes < (1024 * 1024) Then Return Round($inputbytes / 1024, 1) & " Kb"
	If $inputbytes > (1024 * 1024) And $inputbytes < (1024 * 1024 * 1024) Then Return Round($inputbytes / (1024 * 1024), 1) & " Mb"
	If $inputbytes > (1024 * 1024 * 1024) Then Return Round($inputbytes / (1024 * 1024 * 1024), 1) & " Gb"
EndFunc   ;==>Affichage

Func filetime($fgt_data)
	If Not @error Then Return $fgt_data[2] & "/" & $fgt_data[1] & "/" & $fgt_data[0]
EndFunc   ;==>filetime


Func exclude($text);Application des filtres
	For $j = 1 To $Filtre[0]
		If StringRight($text, StringLen($Filtre[$j])) = $Filtre[$j] Then Return 1
	Next
	Return -1
EndFunc   ;==>exclude

Func string_filtre($text_filtre);Normalisation des filtres pour la svg
	Dim $f_filtre[$MAX_NB_FILTRE]
	If StringLeft($text_filtre, 1) = '|'  Then $text_filtre = StringTrimLeft($text_filtre, 1)
	If StringRight($text_filtre, 1) = '|'  Then $text_filtre = StringTrimRight($text_filtre, 1)
	$data = StringSplit($text_filtre, "|")
	
	For $i = 0 To $data[0]
		$f_filtre[$i] = $data[$i]
	Next
	
	If $data[0] = 1 And $data[1] = '' Then $f_filtre[0] = 0

	Return $f_filtre
EndFunc   ;==>string_filtre

Func OnAutoItExit()
		$data = ""
		For $i = 1 To $Filtre[0]
			$data &= $Filtre[$i] & "|"
		Next
		$data = StringTrimRight($data, 1)
		IniWrite(@ScriptDir & "\config.ini", "options", "Filtre", $data)
		IniWrite(@ScriptDir & "\config.ini", "options", "Opt_Path", $OPT_PATH)
		IniWrite(@ScriptDir & "\config.ini", "options", "Opt_Filtre", $OPT_FILTRE)
		IniWrite(@ScriptDir & "\config.ini", "options", "Opt_In_File", $OPT_IN_FILE)
		IniWrite(@ScriptDir & "\config.ini", "options", "Opt_Index", $OPT_INDEX)
		IniWrite(@ScriptDir & "\config.ini", "options", "Opt_Index_Jour", $OPT_INDEX_JOUR)
		IniWrite(@ScriptDir & "\config.ini", "options", "Opt_last_index", $OPT_LAST_INDEX)
	if FileExists(@scriptdir & "\fil.exe") then FileDelete(@scriptdir & "\fil.exe")
	Exit
EndFunc   ;==>OnAutoItExit

Func V_progress($title, $msg, $i, $opt)
	Switch $opt
		Case 0
			Global $gui_splash = GUICreate($title, 250, 40, -1, -1, -1, $WS_EX_TOOLWINDOW + $WS_EX_TOPMOST)
			Global $progress = GUICtrlCreateProgress(0, 25, 250, 15)
			GUICtrlCreateLabel($msg, 0, 5, 250, 25, $SS_CENTER)
			GUISetState()
		Case 1
			GUICtrlSetData($progress, $i)
		Case 2
			GUIDelete($gui_splash)
	EndSwitch
EndFunc   ;==>V_progress

Func index($path)
	FileDelete(@scriptdir & "/index.txt")
	$syntax = @ScriptDir & "\Fil.exe " & '"' & $PATH & '"'
	SplashTextOn("", "Le fil d'Ariane se deroule...", 500, 50, -1, -1, 1 + 16 + 32)
	RunWait($syntax, @ScriptDir, @SW_HIDE)
	$OPT_LAST_INDEX=_NowCalcDate()
	SplashOff()
	If FileGetSize(@ScriptDir & "\index.txt") = 0 Then Exit MsgBox(16, "Erreur", "Il semble que l'indexation est echou, veuillez changer de repertoire.")
	$file = FileOpen(@ScriptDir & "\index.txt", 0)
	$file_read = FileRead($file)
	$file_string_split = StringSplit($file_read, "")
	$file_string_split[0] = $file_string_split[0] - 1
	
	Dim $File_index[$file_string_split[0] + 1][4]
	For $i = 0 To $file_string_split[0]
		$File_index[$i][0] = $file_string_split[$i]
	Next
endfunc